'use strict';

Object.defineProperty(exports, "__esModule", {
   value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /*jshint esversion: 6 */
/*
label.js
========
Contains methods that give GoDex EZPL commands for priting labels elements.
*/


var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Label = function () {
   function Label() {
      var _this = this;

      var _ref = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

      var _ref$speed = _ref.speed;
      var speed = _ref$speed === undefined ? 2 : _ref$speed;
      var _ref$darkness = _ref.darkness;
      var darkness = _ref$darkness === undefined ? 5 : _ref$darkness;
      var _ref$leftMargin = _ref.leftMargin;
      var leftMargin = _ref$leftMargin === undefined ? 26 : _ref$leftMargin;
      var _ref$rotate = _ref.rotate;
      var rotate = _ref$rotate === undefined ? 150 : _ref$rotate;
      var _ref$rowOffset = _ref.rowOffset;
      var rowOffset = _ref$rowOffset === undefined ? -25 : _ref$rowOffset;
      var _ref$width = _ref.width;
      var width = _ref$width === undefined ? 80 : _ref$width;
      var _ref$length = _ref.length;
      var length = _ref$length === undefined ? 52 : _ref$length;
      var _ref$gap = _ref.gap;
      var gap = _ref$gap === undefined ? 2 : _ref$gap;
      var _ref$startPos = _ref.startPos;
      var startPos = _ref$startPos === undefined ? 20 : _ref$startPos;
      var _ref$copies = _ref.copies;
      var copies = _ref$copies === undefined ? 1 : _ref$copies;

      _classCallCheck(this, Label);

      this.config = { speed: speed, darkness: darkness, leftMargin: leftMargin, rotate: rotate, rowOffset: rowOffset, width: width, length: length, gap: gap, startPos: startPos, copies: copies };

      this.cmd = {
         speed: function speed() {
            return '^S' + _this.config.speed + '\n';
         },
         darkness: function darkness() {
            return '^H' + _this.config.darkness + '\n';
         },
         leftMargin: function leftMargin() {
            return '^R' + _this.config.leftMargin + '\n';
         },
         rotate: function rotate() {
            return '~R' + _this.config.rotate + '\n';
         },
         rowOffset: function rowOffset() {
            return '~Q' + _this.config.rowOffset + '\n';
         },
         labelDim: function labelDim() {
            return '^W' + _this.config.width + '\n^Q' + _this.config.length + ',' + _this.config.gap + '\n';
         },
         startPos: function startPos() {
            return '^E' + _this.config.startPos + '\n';
         },
         copies: function copies() {
            return '^C' + _this.config.copies + '\n';
         },

         startLabelNormal: function startLabelNormal() {
            return '^L\n';
         }, // if mode = 0 || undefined
         startLabelInverse: function startLabelInverse() {
            return '^LI\n';
         }, // if mode = 1
         startLabelMirror: function startLabelMirror() {
            return '^LM\n';
         }, // if mode = 2
         end: function end() {
            return 'E\n';
         }
      };

      this.set = {
         speed: function speed(x) {
            _this.config.speed = x;
         },
         darkness: function darkness(x) {
            _this.config.darkness = x;
         },
         leftMargin: function leftMargin(x) {
            _this.config.leftMargin = x;
         },
         rotate: function rotate(x) {
            _this.config.rotate = x;
         },
         rowOffset: function rowOffset(x) {
            _this.config.rowOffset = x;
         },
         width: function width(x) {
            _this.config.width = x;
         },
         length: function length(x) {
            _this.config.length = x;
         },
         gap: function gap(x) {
            _this.config.gap = x;
         },
         startPos: function startPos(x) {
            _this.config.startPos = x;
         },
         copies: function copies(x) {
            _this.config.copies = x;
         }
      };
      this.labelCmd = '';
   }

   _createClass(Label, [{
      key: 'addLabelCmd',
      value: function addLabelCmd(command) {
         if (command) this.labelCmd += command;
      }
   }, {
      key: 'getPrintCommand',
      value: function getPrintCommand() {
         var mode = arguments.length <= 0 || arguments[0] === undefined ? 0 : arguments[0];

         var prefix = this.cmd.speed() + this.cmd.darkness() + this.cmd.leftMargin() + this.cmd.rotate() + this.cmd.rowOffset() + this.cmd.labelDim() + this.cmd.startPos() + this.cmd.copies() + (mode === 0 ? this.cmd.startLabelNormal() : mode === 1 ? this.cmd.startLabelInverse() : this.cmd.startLabelMirror());
         return prefix + this.labelCmd + this.cmd.end();
      }
      // Horizontal line commmand

   }, {
      key: 'lineHor',
      value: function lineHor(xStart, xEnd, y, t) {
         var yStart = y,
             yEnd = y + t;
         return 'La,' + xStart + ',' + yStart + ',' + xEnd + ',' + yEnd + '\n';
      }
   }, {
      key: 'addLineHor',
      value: function addLineHor(xStart, xEnd, y, t) {
         this.labelCmd += this.lineHor(xStart, xEnd, y, t);
      }

      // Vertical line commmand

   }, {
      key: 'lineVer',
      value: function lineVer(x, yStart, yEnd, t) {
         var xStart = x,
             xEnd = x + t;
         return 'La,' + xStart + ',' + yStart + ',' + xEnd + ',' + yEnd + '\n';
      }
   }, {
      key: 'addLineVer',
      value: function addLineVer(x, yStart, yEnd, t) {
         this.labelCmd += this.lineVer(x, yStart, yEnd, t);
      }

      // Rectangle command drawing

   }, {
      key: 'rect',
      value: function rect(xStart, yStart, width, height, t) {
         return 'R' + xStart + ',' + yStart + ',' + (xStart + width) + ',' + (yStart + height) + ',' + t + ',' + t + '\n';
      }
   }, {
      key: 'addRect',
      value: function addRect(xStart, yStart, xEnd, yEnd, t) {
         this.labelCmd += this.rect(xStart, yStart, xEnd, yEnd, t);
      }

      // Text command

   }, {
      key: 'text',
      value: function text(_text, x, y, s) {
         var i = [6, 8, 10, 12, 14, 18, 24, 30];
         var j = ['A', 'B', 'C', 'D', 'E', 'F', 'G', 'H'];
         var k = _underscore2.default.map(i, function (num) {
            return Math.abs(num - s);
         });
         var l = _underscore2.default.lastIndexOf(k, _underscore2.default.min(k));
         return "A" + j[l] + "," + x + "," + y + ",1,1,1,0," + _text + "\n";
      }
   }, {
      key: 'addText',
      value: function addText(text, x, y, s) {
         var style = arguments.length <= 4 || arguments[4] === undefined ? 0 : arguments[4];

         this.labelCmd += this.text(text, x, y, s, style = 0);
      }
   }, {
      key: 'barcode',
      value: function barcode(type, x, y, narrow, width, height, rotation, readable, data) {
         var barType = { 'CODE39': 'A', 'EAN8': 'B', 'EAN13': 'E', 'UPCA': 'H', 'UPCE': 'K', 'CODE93': 'P', 'CODE128': 'Q' };
         return 'B' + barType[type] + ',' + x + ',' + y + ',' + narrow + ',' + width + ',' + height + ',' + rotation + ',' + readable + ',' + data + '\n';
      }
   }, {
      key: 'addBarcode',
      value: function addBarcode(type, x, y, narrow, width, height, rotation, readable, data) {
         this.labelCmd += this.barcode(type, x, y, narrow, width, height, rotation, readable, data);
      }
   }]);

   return Label;
}();

exports.default = Label;